"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Fragment = exports.VDOMNode = void 0;
var tslib_1 = require("tslib");
var VDOMNode = exports.VDOMNode = /** @class */ (function () {
    function VDOMNode(node) {
        var _b;
        this.node = node;
        if (node instanceof Text) {
            this.text = node.nodeValue;
            return;
        }
        if (!(node instanceof Element))
            return;
        var tagName = (_b = node, _b.tagName), attributes = _b.attributes, style = _b.style, childNodes = _b.childNodes;
        this.tagName = tagName.toLowerCase();
        var props = Array.from(attributes, function (_b) {
            var name = _b.name, value = _b.value;
            return name !== 'style' && [VDOMNode.attrsMap[name] || name, value];
        }).filter(Boolean);
        if (props[0])
            this.props = Object.fromEntries(props);
        var styles = Array.from(style, function (key) { return [key, style[key]]; });
        if (styles[0])
            this.style = Object.fromEntries(styles);
        var children = Array.from(childNodes, function (node) { return new VDOMNode(node); });
        if (children[0])
            this.children = children;
    }
    Object.defineProperty(VDOMNode.prototype, "selector", {
        get: function () {
            var _b;
            var tagName = (_b = this, _b.tagName), props = _b.props;
            return tagName && VDOMNode.selectorOf(tagName, props === null || props === void 0 ? void 0 : props.className);
        },
        enumerable: false,
        configurable: true
    });
    var _a;
    _a = VDOMNode;
    VDOMNode.selectorOf = function (tagName, className) {
        return tagName.toLowerCase() +
            (className ? ".".concat(className.trim().replace(/\s+/, '.')) : '');
    };
    VDOMNode.propsMap = { className: 'class', htmlFor: 'for' };
    VDOMNode.attrsMap = Object.fromEntries(Object.entries(_a.propsMap).map(function (item) { return item.reverse(); }));
    return VDOMNode;
}());
var Fragment = function (_b) {
    var style = _b.style, children = _b.children, props = tslib_1.__rest(_b, ["style", "children"]);
    return ({
        props: props,
        style: style,
        children: children
    });
};
exports.Fragment = Fragment;
