"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsxs = exports.jsx = void 0;
var tslib_1 = require("tslib");
var web_utility_1 = require("web-utility");
var VDOM_1 = require("./dist/VDOM");
/**
 * @see {@link https://github.com/reactjs/rfcs/blob/createlement-rfc/text/0000-create-element-changes.md}
 * @see {@link https://babeljs.io/docs/babel-plugin-transform-react-jsx}
 */
function jsx(type, _a, key) {
    var _b;
    var style = _a.style, children = _a.children, props = tslib_1.__rest(_a, ["style", "children"]);
    if (typeof type === 'function' && (0, web_utility_1.isHTMLElementClass)(type))
        type = (0, web_utility_1.tagNameOf)(type);
    return typeof type === 'string'
        ? {
            key: key,
            selector: VDOM_1.VDOMNode.selectorOf(type, props.className),
            tagName: type,
            props: props,
            style: style,
            children: (_b = (children instanceof Array
                ? children
                : children && [children])) === null || _b === void 0 ? void 0 : _b.map(function (node) { return (typeof node === 'string' ? { text: node } : node); })
        }
        : type(tslib_1.__assign({ style: style, children: children }, props));
}
exports.jsx = jsx;
exports.jsxs = jsx;
